<?php

    

/*
* $Id: zipur_toolbox.php
* $Loc: /admin/includes/functions/
*
* Name: zipurToolbox
* Version: 0.2.0
* Release Date: 08/09/2020
* Author: Preston Lord
* 	 aka zipurman / zipur.ca / plord@inetx.ca
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2020: Preston Lord - @zipurman - Intricate Networks Inc.
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with zipurUpdater v0.2.0)
*/





    function zip_db_connect( $server = DB_SERVER, $username = DB_SERVER_USERNAME, $password = DB_SERVER_PASSWORD, $database = DB_DATABASE, $link = 'db_link' ) {

        global $$link;

        if ( USE_PCONNECT == 'true' ) {
            $server = 'p:' . $server;
        }

        $$link = mysqli_connect( $server, $username, $password, $database );

        if ( ! mysqli_connect_errno() ) {
            mysqli_set_charset( $$link, 'utf8' );
        }

        @mysqli_query( $$link, 'SET SESSION sql_mode=""' );

        return $$link;
    }

    zip_db_connect();

    /** Copied from core to adjust behaviors on errors
     *
     * @param        $query
     * @param string $link
     *
     * @return bool|mysqli_result
     */
    function zip_db_query( $query, $link = 'db_link' ) {

        global $$link, $logger;

        return mysqli_query( $$link, $query );
    }

    /**
     * Function to check POST/GET/COOKIE/SESSION vars and validate if needed with defaults
     *
     * @param        $var_to_check
     * @param        $default_value
     * @param string $checkformat
     * @param string $if_invalid_value
     * @param null   $current_val
     *
     * @return int|null
     */
    function zipVarCheck( $var_to_check, $default_value, $checkformat = "", $if_invalid_value = "", $current_val = null ) {

        if ( $current_val != null && $default_value == $current_val ) {
            $y = $current_val;
        } else if ( $current_val != "" && $current_val != null ) {
            $y = $current_val;
        } else {
            if ( isset( $_GET[ $var_to_check ] ) ) {
                $y = $_GET[ $var_to_check ];
            } elseif ( isset( $_POST[ $var_to_check ] ) ) {
                $y = $_POST[ $var_to_check ];
            } elseif ( isset( $_COOKIE[ $var_to_check ] ) ) {
                $y = $_COOKIE[ $var_to_check ];
            } elseif ( isset( $_SESSION[ $var_to_check ] ) ) {
                $y = $_SESSION[ $var_to_check ];
            } else {
                $y = $default_value;
            }
        }
        $checkformat = (string) $checkformat;

        if ( strpos( "$checkformat", "FILTER_VALIDATE_INT" ) !== false ) {
            if ( filter_var( $y, FILTER_VALIDATE_INT ) === 0 || ! filter_var( $y, FILTER_VALIDATE_INT ) === false ) {
                //all okay with $y
            } else {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_PIN" ) !== false ) {
            $opt = [ "options" => [ "regexp" => "/^[0-9]{4,8}$/" ] ];
            if ( filter_var( $y, FILTER_VALIDATE_REGEXP, $opt ) === false ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_FLOAT" ) !== false ) {
            $y = (float) $y;
            if ( ! filter_var( $y, FILTER_VALIDATE_FLOAT ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_DATE" ) !== false ) {
            if ( ! validateDate( $y, 'm/d/Y' ) ) {
                $y = $if_invalid_value;
            }
            //double check date length as weird values like 08/14/-18343974928 return true
            if ( strlen( $y ) != '10' ) {
                $y = $if_invalid_value;
            }

        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_EMAIL" ) !== false ) {
            if ( ! filter_var( $y, FILTER_VALIDATE_EMAIL ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_URL" ) !== false ) {
            if ( ! filter_var( $y, FILTER_VALIDATE_URL ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_ARRAY" ) !== false ) {
            if ( ! is_array( $y ) ) {
                if ( is_array( $if_invalid_value ) ) {
                    $y = $if_invalid_value;
                } else {
                    $y = [ $if_invalid_value ];
                }
            }
        }

        return $y;
    }

    /**
     * @param        $date
     * @param string $format
     *
     * @return bool
     */
    function validateDate( $date, $format = 'Y-m-d H:i:s' ) {

        $d = DateTime::createFromFormat( $format, $date, new DateTimeZone( CFG_TIME_ZONE ) );

        return $d && $d->format( $format ) == $date;
    }

    /** Create a nested array from a directory root
     *
     * @param       $path
     * @param array $ignorefolders
     * @param int   $type
     * @param false $convertadmin
     */
    function zipGetDirArray( $path, $ignorefolders = [], $type = 0, $convertadmin = false ) {

        global $installedfiles, $cleancorefiles, $version, $customadminpath;
        exec( 'ls ' . $path, $files );
        foreach ( $files as $file ) {
            if ( is_dir( $path . '/' . $file ) ) {
                if ( ( in_array( basename( $file ), $ignorefolders ) ) ) {
                    //do nothing for ignored folders
                } else {
                    zipGetDirArray( $path . '/' . $file, $ignorefolders, $type, $convertadmin );
                }
            } else {
                if ( ( in_array( basename( $file ), $ignorefolders ) ) ) {
                    //do nothing for ignored files
                } else {
                    if ( empty( $type ) ) {
                        $keypath = $path . '/' . $file;
                        $keypath = str_replace( DIR_FS_CATALOG, '', $keypath );

                        if ( $convertadmin ) {
                            $keypath = preg_replace( '/^\/' . $customadminpath . '/', '/admin', $keypath, 1 );
                        }

                        $installedfiles[ $keypath ] = hash_file( 'md5', $path . '/' . $file );
                    } else if ( $type == 1 ) {
                        $keypath = $path . '/' . $file;

                        $ospath                     = ( zipCheckIfPhoenix() ) ? 'CE-Phoenix-' : 'oscommerce-';
                        $ospath2                    = ( zipCheckIfPhoenix() ) ? '' : '/catalog';
                        $keypath                    = str_replace( DIR_FS_ADMIN . 'clean_core/' . $ospath . trim( $version ) . $ospath2, '', $keypath );
                        $keypath                    = preg_replace( '/^\/admin/', '/' . $customadminpath . '', $keypath, 1 );
                        $cleancorefiles[ $keypath ] = hash_file( 'md5', $path . '/' . $file );
                    } else if ( $type == 2 ) {

                        //ignore any non-php files for catching patch versions
                        if ( strpos( $file, '.php' ) !== false ) {
                            $keypath          = $path . '/' . $file;
                            $cleancorefiles[] = $keypath;
                        }

                    }
                }
            }
        }
    }

    /**
     * For debugging arrays/objects
     *
     * @param     $arraytoshow
     * @param int $showfullscreen
     */
    function zipShowMe( $arraytoshow, $showfullscreen = 0 ) {

        if ( $showfullscreen == 1 ) {
            echo '<div style="position: fixed; top: 0px; left: 0px; width: 2000px; height: 1000px; overflow: auto;">';
        }
        $newarray = $arraytoshow;

        echo '<pre>';
        var_dump( $newarray );
        echo '</pre>';
        if ( $showfullscreen == 1 ) {
            echo '</div>';
        }
    }

    /**
     * Check version to make sure min / max are met
     *
     * @param $requiredversion
     * @param $maxversion
     *
     * @return int[]
     */
    function zipCheckUpdateVersion( $requiredversion, $maxversion ) {

        global $version;
        $versionok            = [ 1, 1 ];
        $versionokmaster      = 0;
        $versioncheck         = explode( '.', $version );
        $requiredversioncheck = explode( '.', $requiredversion );
        foreach ( $requiredversioncheck as $key => $reqver ) {
            if ( (int) $reqver > (int) $versioncheck[ $key ] ) {
                if ( empty( $versionokmaster ) ) {
                    $versionok[0] = 0;
                }
            } else if ( (int) $reqver < (int) $versioncheck[ $key ] ) {
                $versionokmaster = 1;
            }
        }
        $versionokmaster      = 0;
        $requiredversioncheck = explode( '.', $maxversion );
        foreach ( $requiredversioncheck as $key => $reqver ) {
            if ( (int) $reqver < (int) $versioncheck[ $key ] ) {
                if ( empty( $versionokmaster ) ) {
                    $versionok[1] = 0;
                }
            } else if ( (int) $reqver > (int) $versioncheck[ $key ] ) {
                $versionokmaster = 1;
            }
        }

        return $versionok;
    }

    /** Check if version needs upgrade
     *
     * @param $oldversion
     * @param $newversion
     *
     * @return int
     */
    function zipCheckNeedsUpdateVersion( $oldversion, $newversion ) {

        $versionok            = 1;
        $versionokmaster      = 0;
        $versioncheck         = explode( '.', $oldversion );
        $requiredversioncheck = explode( '.', $newversion );
        foreach ( $requiredversioncheck as $key => $reqver ) {
            if ( (int) $reqver > (int) $versioncheck[ $key ] ) {
                if ( empty( $versionokmaster ) ) {
                    $versionok = 0;
                }
            } else if ( (int) $reqver < (int) $versioncheck[ $key ] ) {
                $versionokmaster = 1;
            }
        }

        return $versionok;
    }

    /** Allow detect if OSC ot CE Phoenix
     *
     * @return bool
     */
    function zipCheckIfPhoenix() {

        if ( PROJECT_VERSION == 'OSCOM CE Phoenix' ) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * Adds bootstrap to admin tools if in OSC and not Phoenix
     */
    function zipOscCss() {

        if ( ! zipCheckIfPhoenix() ) {
            ?>
            <link rel="stylesheet"
                  href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/css/bootstrap.min.css"
                  integrity="sha256-aAr2Zpq8MZ+YA/D6JtRD3xtrwpEz2IqOS+pWD/7XKIw=" crossorigin="anonymous"/>
            <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.13.1/css/all.min.css"
                  integrity="sha256-2XFplPlrFClt0bIdPgpz8H7ojnk10H69xRqd9+uTShA=" crossorigin="anonymous"/>

            <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"
                    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
                    crossorigin="anonymous"></script>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/js/bootstrap.min.js"
                    integrity="sha256-OFRAJNoaD8L3Br5lglV7VyLRf0itmoBzWUoM+Sji4/8=" crossorigin="anonymous"></script>
            <style>
                #adminAppMenu {
                    font-size: 0.7rem;
                }

                .table-responsive {
                    padding: 0px 20px;
                }
            </style>
            <?php
        }
    }

    function zipGetFileVersion($filename) {

        //get this tool version number from above content block. Dynamically created by Update Creator.
        $getcheckfile  = file_get_contents( $filename );
        $checkstartloc = strpos( $getcheckfile, 'Version' );
        $checkendloc   = strpos( $getcheckfile, "\n", $checkstartloc );
        $versiontext   = substr( $getcheckfile, $checkstartloc, $checkendloc - $checkstartloc + 2 );

        return preg_replace( '/[^0-9.]/', '', $versiontext );
    }

    /**
     * Ass banner to top of zipur addons for easy support, docs, etc.
     */
    function zipAdBanner() {

        ?>
        <div style="text-align: right; padding: 0px 40px; margin-bottom: 10px;">
            This tool created by @zipurman <a href="https://zipur.ca" target="_blank">zipur.ca</a>
            <?php
                if ( ! zipCheckIfPhoenix() ) {
                    ?>
                    <div style="text-align: center; padding: 10px; background-color: #d04949; border: 1px solid #991e1e; color: #eee; width: 60%; margin: 10px auto; border-radius: 0.5rem;">
                        Upgrade to <a href="https://www.oscommerce.com/Products" target="_blank" style="color: #000;">CE
                            Phoenix</a> today to get the most out of your OSCommerce Experience.
                    </div>
                    <?php
                }
            ?>
        </div>
        <?php
    }