<?php


/*
* $Id: update.php
* $Loc: admin/updates/zipurToolbox
*
* Name: zipurToolbox
* Version: 0.2.0
* Release Date: 08/09/2020
* Author: Preston Lord
* 	 aka zipurman / zipur.ca / plord@inetx.ca
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2020: Preston Lord - @zipurman - Intricate Networks Inc.
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with zipurUpdater v0.2.0)
*/

$update_config = [
	'description'		=> 'Used to update and install into Phoenix and OSCommerce with ease.',
	'required_version'	=> '1.0.7.0',
	'max_version'		=> '1.9.9.9',
	'osc_required_version'	=> '2.3.0.0',
	'osc_max_version'	=> '2.9.9.9',
	'supports_osc'		=> true,
	'supports_phoenix'		=> true,
	'update_version'	=> '0.2.0',
	'update_date'		=> '08/09/2020',
	'update_author'		=> 'Preston Lord',
	'update_all_php'	=> true,
	'update_contact'	=> 'aka zipurman / zipur.ca / plord@inetx.ca',
	'update_license'	=> 'Released under the GNU General Public License',
	'update_comments'	=> 'Copyright (c) 2020: Preston Lord - @zipurman - Intricate Networks Inc.


  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.',
	'tasks'			=> 'install|remove',
];

$update_pre_install_actions = [
];


$update_post_install_actions = [
	[
		'type'		=> 'files_delete',
		'action'	=> 'install',
		'optional'	=> true,
		'items'		=> [
			'/admin/includes/boxes/zipur_updater.php',
			'/admin/includes/functions/zipur_updater.php',
			'/admin/includes/languages/english/modules/boxes/zipur_updater.php',
			'/admin/includes/languages/english/zipur_updater.php',
			'/admin/zipur_updater.php',
		],
	],
];


$update_uninstall_actions = [
	[
		'type'		=> 'files_delete',
		'action'	=> 'install',
		'optional'	=> true,
		'items'		=> [
			'/admin/includes/boxes/zipur_toolbox.php',
			'/admin/includes/functions/zipur_toolbox.php',
			'/admin/includes/languages/english/modules/boxes/zipur_toolbox.php',
			'/admin/includes/languages/english/zipur_toolbox.php',
			'/admin/zipur_toolbox.php',
		],
	],
];


?>